Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 14977)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 14983)
@@ -38,5 +38,5 @@
     protected Dictionary<string, DataRow> allInOneDataRows;
     protected DataTable allInOneDataTable;
-    protected DataTableControl allInOneDataTableControl;
+    protected DataTableView allInOneDataTableView;
 
     public LineChartView() {
@@ -45,5 +45,5 @@
 
       allInOneDataRows = new Dictionary<string, DataRow>();
-      allInOneDataTable= new DataTable();
+      allInOneDataTable = new DataTable();
     }
 
@@ -71,9 +71,9 @@
       return Content.AllInOneMode ? 1 : base.GetNumberOfVisibleDataTables();
     }
-    protected override IEnumerable<DataTableControl> GetVisibleDataTables() {
+    protected override IEnumerable<DataTableView> GetVisibleDataTables() {
       if (Content.AllInOneMode) {
-        if (allInOneDataTableControl == null)
-          allInOneDataTableControl = new DataTableControl() { Content = allInOneDataTable };
-        return new[] { allInOneDataTableControl };
+        if (allInOneDataTableView == null)
+          allInOneDataTableView = new DataTableView() { Content = allInOneDataTable };
+        return new[] { allInOneDataTableView };
       }
       return base.GetVisibleDataTables();
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 14977)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 14983)
@@ -37,5 +37,5 @@
   public partial class PreprocessingChartView : PreprocessingCheckedVariablesView {
     protected Dictionary<string, DataTable> dataTables;
-    protected Dictionary<string, DataTableControl> dataTableControls;
+    protected Dictionary<string, DataTableView> dataTableViews;
 
     public static readonly Color[] Colors = {
@@ -51,5 +51,5 @@
       InitializeComponent();
       dataTables = new Dictionary<string, DataTable>();
-      dataTableControls = new Dictionary<string, DataTableControl>();
+      dataTableViews = new Dictionary<string, DataTableView>();
     }
 
@@ -66,9 +66,9 @@
     }
 
-    protected virtual IEnumerable<DataTableControl> GetVisibleDataTables() {
+    protected virtual IEnumerable<DataTableView> GetVisibleDataTables() {
       foreach (var name in Content.VariableItemList.CheckedItems) {
-        if (!dataTableControls.ContainsKey(name.Value.Value))
-          dataTableControls.Add(name.Value.Value, new DataTableControl() { Content = dataTables[name.Value.Value] });
-        yield return dataTableControls[name.Value.Value];
+        if (!dataTableViews.ContainsKey(name.Value.Value))
+          dataTableViews.Add(name.Value.Value, new DataTableView() { Content = dataTables[name.Value.Value], ShowName = false });
+        yield return dataTableViews[name.Value.Value];
       }
     }
@@ -80,5 +80,5 @@
     protected virtual void InitData() {
       dataTables.Clear();
-      dataTableControls.Clear();
+      dataTableViews.Clear();
       foreach (var variable in Content.VariableItemList.Select(v => v.Value)) {
         dataTables.Add(variable, CreateDataTable(variable));
@@ -129,5 +129,5 @@
       base.RemoveVariable(name);
       dataTables.Remove(name);
-      dataTableControls.Remove(name);
+      dataTableViews.Remove(name);
 
       GenerateLayout();
@@ -139,5 +139,5 @@
       var newDataTable = CreateDataTable(name);
       dataTables.Add(name, newDataTable);
-      dataTableControls[name].Content = newDataTable;
+      dataTableViews[name].Content = newDataTable;
       GenerateLayout();
     }
@@ -191,5 +191,5 @@
     }
 
-    private void AddDataTableToTableLayout(DataTableControl dataTable, int row, int col) {
+    private void AddDataTableToTableLayout(DataTableView dataTable, int row, int col) {
       //dataView.Classification = Classification;
       //dataView.IsDetailedChartViewEnabled = IsDetailedChartViewEnabled;
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 14977)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 14983)
@@ -416,8 +416,9 @@
           foreach (var dataRow in dataTable.Rows)
             dataRow.VisualProperties.IsVisibleInLegend = groupingComboBox.SelectedIndex > 0;
-          var pcv = new DataTableControl {
+          var pcv = new DataTableView {
             Name = key.ToString(),
             Content = dataTable,
             Dock = DockStyle.Fill,
+            ShowName = false
             //ShowLegend = false,
             //XAxisFormat = "G3"
@@ -444,13 +445,14 @@
           }
           scatterPlot.VisualProperties.Title = string.Empty;
-          var scatterPlotControl = new ScatterPlotControl {
+          var scatterPlotView = new ScatterPlotView {
             Name = key.ToString(),
             Content = scatterPlot,
             Dock = DockStyle.Fill,
+            ShowName = false
             //ShowLegend = false,
             //XAxisFormat = "G3"
           };
-          //scatterPlotControl.DoubleClick += ScatterPlotDoubleClick; // ToDo: not working; double click is already handled by the chart
-          bodyCache.Add(key, scatterPlotControl);
+          //scatterPlotView.DoubleClick += ScatterPlotDoubleClick; // ToDo: not working; double click is already handled by the chart
+          bodyCache.Add(key, scatterPlotView);
         }
       }
@@ -536,7 +538,7 @@
     //Open scatter plot in new tab with new content when double clicked
     private void ScatterPlotDoubleClick(object sender, EventArgs e) {
-      var scatterPlotControl = (ScatterPlotControl)sender;
+      var scatterPlotView = (ScatterPlotView)sender;
       var scatterContent = new SingleScatterPlotContent(Content.PreprocessingData);
-      ScatterPlot scatterPlot = scatterPlotControl.Content;
+      ScatterPlot scatterPlot = scatterPlotView.Content;
 
       //Extract variable names from scatter plot and set them in content
@@ -552,5 +554,5 @@
     //open histogram in new tab with new content when double clicked
     private void HistogramDoubleClick(object sender, EventArgs e) {
-      DataTableControl pcv = (DataTableControl)sender;
+      DataTableView pcv = (DataTableView)sender;
       HistogramContent histoContent = new HistogramContent(Content.PreprocessingData);  // create new content     
                                                                                         //ToDo: histoContent.VariableItemList = Content.CreateVariableItemList();
@@ -655,7 +657,7 @@
       int pointSize = (int)pointSizeNumericUpDown.Value;
       foreach (var control in bodyCache.ToList()) {
-        var scatterPlotControl = control.Value as ScatterPlotControl;
-        if (scatterPlotControl != null) {
-          foreach (var row in scatterPlotControl.Content.Rows) {
+        var scatterPlotView = control.Value as ScatterPlotView;
+        if (scatterPlotView != null) {
+          foreach (var row in scatterPlotView.Content.Rows) {
             row.VisualProperties.PointSize = pointSize;
           }
@@ -666,7 +668,7 @@
       float opacity = (float)pointOpacityNumericUpDown.Value;
       foreach (var control in bodyCache.ToList()) {
-        var scatterPlotControl = control.Value as ScatterPlotControl;
-        if (scatterPlotControl != null) {
-          foreach (var row in scatterPlotControl.Content.Rows) {
+        var scatterPlotView = control.Value as ScatterPlotView;
+        if (scatterPlotView != null) {
+          foreach (var row in scatterPlotView.Content.Rows) {
             var color = row.VisualProperties.Color;
             if (color.IsEmpty)
@@ -700,7 +702,7 @@
         }
 
-        var scatterPlotControl = control.Value as ScatterPlotControl;
-        if (scatterPlotControl != null) {
-          foreach (var row in scatterPlotControl.Content.Rows) {
+        var scatterPlotView = control.Value as ScatterPlotView;
+        if (scatterPlotView != null) {
+          foreach (var row in scatterPlotView.Content.Rows) {
             row.VisualProperties.IsRegressionVisibleInLegend = false;
             row.VisualProperties.RegressionType = regressionType;
@@ -726,5 +728,5 @@
         }
 
-        var histogramControl = control.Value as DataTableControl;
+        var histogramControl = control.Value as DataTableView;
         if (histogramControl != null) {
           foreach (var row in histogramControl.Content.Rows) {
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 14977)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 14983)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ScatterPlotSingleView));
-      this.scatterPlotControl = new HeuristicLab.Analysis.Views.ScatterPlotControl();
+      this.scatterPlotView = new HeuristicLab.Analysis.Views.ScatterPlotView();
       this.groupBox1 = new System.Windows.Forms.GroupBox();
       this.useGradientCheckBox = new System.Windows.Forms.CheckBox();
@@ -76,14 +76,14 @@
       this.SuspendLayout();
       // 
-      // scatterPlotControl
-      // 
-      this.scatterPlotControl.Caption = "View";
-      this.scatterPlotControl.Content = null;
-      this.scatterPlotControl.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.scatterPlotControl.Location = new System.Drawing.Point(0, 0);
-      this.scatterPlotControl.Name = "scatterPlotControl";
-      this.scatterPlotControl.ReadOnly = false;
-      this.scatterPlotControl.Size = new System.Drawing.Size(618, 517);
-      this.scatterPlotControl.TabIndex = 0;
+      // ScatterPlotView
+      // 
+      this.scatterPlotView.Caption = "View";
+      this.scatterPlotView.Content = null;
+      this.scatterPlotView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.scatterPlotView.Location = new System.Drawing.Point(0, 0);
+      this.scatterPlotView.Name = "scatterPlotView";
+      this.scatterPlotView.ReadOnly = false;
+      this.scatterPlotView.Size = new System.Drawing.Size(618, 517);
+      this.scatterPlotView.TabIndex = 0;
       // 
       // groupBox1
@@ -269,5 +269,5 @@
       // splitContainer1.Panel2
       // 
-      this.splitContainer1.Panel2.Controls.Add(this.scatterPlotControl);
+      this.splitContainer1.Panel2.Controls.Add(this.scatterPlotView);
       this.splitContainer1.Panel2.Controls.Add(this.gradientPanel);
       this.splitContainer1.Size = new System.Drawing.Size(863, 517);
@@ -345,5 +345,5 @@
     #endregion
 
-    private HeuristicLab.Analysis.Views.ScatterPlotControl scatterPlotControl;
+    private HeuristicLab.Analysis.Views.ScatterPlotView scatterPlotView;
     private System.Windows.Forms.GroupBox groupBox1;
     private System.Windows.Forms.Label label2;
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14977)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14983)
@@ -118,5 +118,5 @@
         vp.YAxisTitle = yVariable;
 
-        scatterPlotControl.Content = scatterPlot;
+        scatterPlotView.Content = scatterPlot;
 
         //save selected x and y variable in content
@@ -128,7 +128,7 @@
 
     private void comboBoxXVariable_SelectedIndexChanged(object sender, EventArgs e) {
-      var oldPlot = scatterPlotControl.Content;
+      var oldPlot = scatterPlotView.Content;
       UpdateScatterPlot();
-      var newPlot = scatterPlotControl.Content;
+      var newPlot = scatterPlotView.Content;
 
       if (oldPlot == null || newPlot == null) return;
@@ -146,7 +146,7 @@
 
     private void comboBoxYVariable_SelectedIndexChanged(object sender, EventArgs e) {
-      var oldPlot = scatterPlotControl.Content;
+      var oldPlot = scatterPlotView.Content;
       UpdateScatterPlot();
-      var newPlot = scatterPlotControl.Content;
+      var newPlot = scatterPlotView.Content;
 
       if (oldPlot == null || newPlot == null) return;
@@ -187,5 +187,5 @@
       int order = (int)polynomialRegressionOrderNumericUpDown.Value;
 
-      foreach (var row in scatterPlotControl.Content.Rows) {
+      foreach (var row in scatterPlotView.Content.Rows) {
         row.VisualProperties.IsRegressionVisibleInLegend = false;
         row.VisualProperties.RegressionType = regressionType;
@@ -199,6 +199,6 @@
 
       // remove rows and re-add them later to avoid firing visual property changd events
-      var rows = scatterPlotControl.Content.Rows.ToDictionary(r => r.Name, r => r);
-      scatterPlotControl.Content.Rows.Clear();
+      var rows = scatterPlotView.Content.Rows.ToDictionary(r => r.Name, r => r);
+      scatterPlotView.Content.Rows.Clear();
 
       if (useGradientCheckBox.Checked) {
@@ -224,5 +224,5 @@
         }
       }
-      scatterPlotControl.Content.Rows.AddRange(rows.Values);
+      scatterPlotView.Content.Rows.AddRange(rows.Values);
     }
 