Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 14583)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.Designer.cs	(revision 14993)
@@ -45,15 +45,25 @@
     /// </summary>
     private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
       this.optionsBox = new System.Windows.Forms.GroupBox();
-      this.label2 = new System.Windows.Forms.Label();
-      this.label1 = new System.Windows.Forms.Label();
+      this.groupingTableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();
+      this.variableLabel = new System.Windows.Forms.Label();
+      this.orderLabel = new System.Windows.Forms.Label();
+      this.aggregationLabel = new System.Windows.Forms.Label();
+      this.orderComboBox = new System.Windows.Forms.ComboBox();
+      this.classifierComboBox = new System.Windows.Forms.ComboBox();
       this.aggregationComboBox = new System.Windows.Forms.ComboBox();
-      this.classifierComboBox = new System.Windows.Forms.ComboBox();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
       this.splitContainer.SuspendLayout();
       this.optionsBox.SuspendLayout();
+      this.groupingTableLayoutPanel.SuspendLayout();
       this.SuspendLayout();
       // 
+      // sizeGroupBox
+      // 
+      this.sizeGroupBox.Location = new System.Drawing.Point(0, 258);
+      // 
       // splitContainer
       // 
@@ -65,57 +75,101 @@
       // optionsBox
       // 
-      this.optionsBox.Controls.Add(this.label2);
-      this.optionsBox.Controls.Add(this.label1);
-      this.optionsBox.Controls.Add(this.aggregationComboBox);
-      this.optionsBox.Controls.Add(this.classifierComboBox);
+      this.optionsBox.Controls.Add(this.groupingTableLayoutPanel);
       this.optionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.optionsBox.Location = new System.Drawing.Point(0, 292);
+      this.optionsBox.Location = new System.Drawing.Point(0, 302);
       this.optionsBox.Name = "optionsBox";
-      this.optionsBox.Size = new System.Drawing.Size(180, 111);
+      this.optionsBox.Size = new System.Drawing.Size(180, 101);
       this.optionsBox.TabIndex = 7;
       this.optionsBox.TabStop = false;
       this.optionsBox.Text = "Grouping Options";
       // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(2, 61);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(67, 13);
-      this.label2.TabIndex = 2;
-      this.label2.Text = "Aggregation:";
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 15);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(48, 13);
-      this.label1.TabIndex = 2;
-      this.label1.Text = "Variable:";
+      // groupingTableLayoutPanel
+      // 
+      this.groupingTableLayoutPanel.ColumnCount = 2;
+      this.groupingTableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
+      this.groupingTableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.groupingTableLayoutPanel.Controls.Add(this.variableLabel, 0, 0);
+      this.groupingTableLayoutPanel.Controls.Add(this.orderLabel, 0, 2);
+      this.groupingTableLayoutPanel.Controls.Add(this.aggregationLabel, 0, 1);
+      this.groupingTableLayoutPanel.Controls.Add(this.orderComboBox, 1, 2);
+      this.groupingTableLayoutPanel.Controls.Add(this.classifierComboBox, 1, 0);
+      this.groupingTableLayoutPanel.Controls.Add(this.aggregationComboBox, 1, 1);
+      this.groupingTableLayoutPanel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupingTableLayoutPanel.Location = new System.Drawing.Point(3, 16);
+      this.groupingTableLayoutPanel.Name = "groupingTableLayoutPanel";
+      this.groupingTableLayoutPanel.RowCount = 3;
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.groupingTableLayoutPanel.Size = new System.Drawing.Size(174, 82);
+      this.groupingTableLayoutPanel.TabIndex = 3;
+      // 
+      // variableLabel
+      // 
+      this.variableLabel.AutoSize = true;
+      this.variableLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.variableLabel.Location = new System.Drawing.Point(3, 0);
+      this.variableLabel.Name = "variableLabel";
+      this.variableLabel.Size = new System.Drawing.Size(48, 27);
+      this.variableLabel.TabIndex = 2;
+      this.variableLabel.Text = "Variable:";
+      this.variableLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      // 
+      // orderLabel
+      // 
+      this.orderLabel.AutoSize = true;
+      this.orderLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.orderLabel.Location = new System.Drawing.Point(3, 54);
+      this.orderLabel.Name = "orderLabel";
+      this.orderLabel.Size = new System.Drawing.Size(48, 28);
+      this.orderLabel.TabIndex = 2;
+      this.orderLabel.Text = "Order:";
+      this.orderLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.toolTip.SetToolTip(this.orderLabel, "Order of Legend Entries");
+      // 
+      // aggregationLabel
+      // 
+      this.aggregationLabel.AutoSize = true;
+      this.aggregationLabel.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.aggregationLabel.Location = new System.Drawing.Point(3, 27);
+      this.aggregationLabel.Name = "aggregationLabel";
+      this.aggregationLabel.Size = new System.Drawing.Size(48, 27);
+      this.aggregationLabel.TabIndex = 2;
+      this.aggregationLabel.Text = "Aggr.:";
+      this.aggregationLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.toolTip.SetToolTip(this.aggregationLabel, "Aggregation");
+      // 
+      // orderComboBox
+      // 
+      this.orderComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.orderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.orderComboBox.FormattingEnabled = true;
+      this.orderComboBox.Location = new System.Drawing.Point(57, 57);
+      this.orderComboBox.Name = "orderComboBox";
+      this.orderComboBox.Size = new System.Drawing.Size(114, 21);
+      this.orderComboBox.TabIndex = 1;
+      this.orderComboBox.SelectedIndexChanged += new System.EventHandler(this.orderComboBox_SelectedIndexChanged);
+      // 
+      // classifierComboBox
+      // 
+      this.classifierComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.classifierComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.classifierComboBox.FormattingEnabled = true;
+      this.classifierComboBox.Location = new System.Drawing.Point(57, 3);
+      this.classifierComboBox.Name = "classifierComboBox";
+      this.classifierComboBox.Size = new System.Drawing.Size(114, 21);
+      this.classifierComboBox.TabIndex = 1;
+      this.classifierComboBox.SelectedIndexChanged += new System.EventHandler(this.classifierComboBox_SelectedIndexChanged);
       // 
       // aggregationComboBox
       // 
-      this.aggregationComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.aggregationComboBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.aggregationComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.aggregationComboBox.FormattingEnabled = true;
-      this.aggregationComboBox.Location = new System.Drawing.Point(5, 79);
+      this.aggregationComboBox.Location = new System.Drawing.Point(57, 30);
       this.aggregationComboBox.Name = "aggregationComboBox";
-      this.aggregationComboBox.Size = new System.Drawing.Size(169, 21);
+      this.aggregationComboBox.Size = new System.Drawing.Size(114, 21);
       this.aggregationComboBox.TabIndex = 1;
       this.aggregationComboBox.SelectedIndexChanged += new System.EventHandler(this.aggregationComboBox_SelectedIndexChanged);
-      // 
-      // classifierComboBox
-      // 
-      this.classifierComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.classifierComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.classifierComboBox.FormattingEnabled = true;
-      this.classifierComboBox.Location = new System.Drawing.Point(5, 33);
-      this.classifierComboBox.Name = "classifierComboBox";
-      this.classifierComboBox.Size = new System.Drawing.Size(169, 21);
-      this.classifierComboBox.TabIndex = 1;
-      this.classifierComboBox.SelectedIndexChanged += new System.EventHandler(this.classifierComboBox_SelectedIndexChanged);
       // 
       // HistogramView
@@ -129,5 +183,6 @@
       this.splitContainer.ResumeLayout(false);
       this.optionsBox.ResumeLayout(false);
-      this.optionsBox.PerformLayout();
+      this.groupingTableLayoutPanel.ResumeLayout(false);
+      this.groupingTableLayoutPanel.PerformLayout();
       this.ResumeLayout(false);
 
@@ -138,7 +193,11 @@
     private System.Windows.Forms.GroupBox optionsBox;
     private System.Windows.Forms.ComboBox classifierComboBox;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.Label variableLabel;
+    private System.Windows.Forms.Label aggregationLabel;
     private System.Windows.Forms.ComboBox aggregationComboBox;
+    private System.Windows.Forms.TableLayoutPanel groupingTableLayoutPanel;
+    private System.Windows.Forms.Label orderLabel;
+    private System.Windows.Forms.ComboBox orderComboBox;
+    private System.Windows.Forms.ToolTip toolTip;
   }
 }