Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs	(revision 14993)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs	(revision 14994)
@@ -22,5 +22,5 @@
 #endregion
 
-namespace HeuristicLab.Problems.DataAnalysis.Views {
+namespace HeuristicLab.DataPreprocessing.Views {
   partial class PreprocessingFeatureCorrelationView {
     /// <summary> 
@@ -48,8 +48,88 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
+      this.correlationView = new HeuristicLab.Problems.DataAnalysis.Views.FeatureCorrelationView();
+      this.variablesLabel = new System.Windows.Forms.Label();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.SuspendLayout();
+      // 
+      // checkInputsTargetButton
+      // 
+      this.checkInputsTargetButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.Inputs;
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(736, 5);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
+      this.checkInputsTargetButton.TabIndex = 14;
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Inputs & Target Variables");
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
+      // 
+      // uncheckAllButton
+      // 
+      this.uncheckAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.None;
+      this.uncheckAllButton.Location = new System.Drawing.Point(766, 5);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
+      this.uncheckAllButton.TabIndex = 12;
+      this.toolTip.SetToolTip(this.uncheckAllButton, "None");
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
+      // 
+      // checkAllButton
+      // 
+      this.checkAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.All;
+      this.checkAllButton.Location = new System.Drawing.Point(706, 5);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(24, 24);
+      this.checkAllButton.TabIndex = 13;
+      this.toolTip.SetToolTip(this.checkAllButton, "All");
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
+      // 
+      // correlationView
+      // 
+      this.correlationView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.correlationView.Caption = "Feature Correlation View";
+      this.correlationView.Content = null;
+      this.correlationView.Location = new System.Drawing.Point(0, 0);
+      this.correlationView.Name = "correlationView";
+      this.correlationView.ReadOnly = false;
+      this.correlationView.Size = new System.Drawing.Size(1013, 640);
+      this.correlationView.TabIndex = 18;
+      // 
+      // variablesLabel
+      // 
+      this.variablesLabel.AutoSize = true;
+      this.variablesLabel.Location = new System.Drawing.Point(650, 11);
+      this.variablesLabel.Name = "variablesLabel";
+      this.variablesLabel.Size = new System.Drawing.Size(50, 13);
+      this.variablesLabel.TabIndex = 15;
+      this.variablesLabel.Text = "Variables";
+      // 
+      // PreprocessingFeatureCorrelationView
+      // 
+      this.Controls.Add(this.variablesLabel);
+      this.Controls.Add(this.checkInputsTargetButton);
+      this.Controls.Add(this.uncheckAllButton);
+      this.Controls.Add(this.checkAllButton);
+      this.Controls.Add(this.correlationView);
+      this.Name = "PreprocessingFeatureCorrelationView";
+      this.Size = new System.Drawing.Size(1013, 640);
       this.ResumeLayout(false);
+      this.PerformLayout();
+
     }
 
     #endregion
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
+    private HeuristicLab.Problems.DataAnalysis.Views.FeatureCorrelationView correlationView;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.Label variablesLabel;
   }
 }
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 14993)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 14994)
@@ -20,10 +20,11 @@
 #endregion
 
-using System.Windows.Forms;
-using HeuristicLab.DataPreprocessing;
+using System;
+using System.Linq;
+using HeuristicLab.Data.Views;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 
-namespace HeuristicLab.Problems.DataAnalysis.Views {
+namespace HeuristicLab.DataPreprocessing.Views {
   [View("Preprocessing Feature Correlation View")]
   [Content(typeof(CorrelationMatrixContent), true)]
@@ -35,13 +36,7 @@
     }
 
-    FeatureCorrelationView correlationView;
-
     public PreprocessingFeatureCorrelationView() {
       InitializeComponent();
-      correlationView = new FeatureCorrelationView();
-      correlationView.Dock = DockStyle.Fill;
-      this.Controls.Add(correlationView);
     }
-
 
     protected override void RegisterContentEvents() {
@@ -61,11 +56,31 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content == null) {
-        correlationView.Content = null;
+      correlationView.Content = Content != null ? Content.ProblemData : null;
+    }
+
+    #region Check Variables
+    private void checkAllButton_Click(object sender, System.EventArgs e) {
+      SetVisibility(x => true);
+    }
+    private void checkInputsTargetButton_Click(object sender, System.EventArgs e) {
+      var ppd = Content.PreprocessingData;
+      SetVisibility(x => ppd.InputVariables.Contains(x) || ppd.TargetVariable == x);
+    }
+    private void uncheckAllButton_Click(object sender, System.EventArgs e) {
+      SetVisibility(x => false);
+    }
+    private void SetVisibility(Func<string, bool> check) {
+      var dataView = (EnhancedStringConvertibleMatrixView)correlationView.Controls.Find("DataView", searchAllChildren: true).Single();
+      var ppd = Content.PreprocessingData;
+      var visibilities = ppd.VariableNames.Where((v, i) => ppd.VariableHasType<double>(i)).Select(check).ToList();
+      if (dataView.Content.Rows != dataView.Content.Columns || dataView.Content.Rows != visibilities.Count)
         return;
-      }
 
-      correlationView.Content = Content.ProblemData;
+      dataView.ColumnVisibility = visibilities;
+      dataView.RowVisibility = visibilities;
+      dataView.UpdateColumnHeaders();
+      dataView.UpdateRowHeaders();
     }
+    #endregion
   }
 }
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 14993)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 14994)
@@ -33,5 +33,5 @@
 
     private PreprocessingContext Context { get; set; }
-    private ITransactionalPreprocessingData PreprocessingData {
+    public ITransactionalPreprocessingData PreprocessingData {
       get { return Context.Data; }
     }