Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 15004)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 15005)
@@ -79,4 +79,10 @@
         <value>00:00:40</value>
       </setting>
+      <setting name="CheckpointInterval" serializeAs="String">
+        <value>18:00:00</value>
+      </setting>
+      <setting name="CheckpointCheckInterval" serializeAs="String">
+        <value>00:05:00</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
     <HeuristicLab.Clients.Hive.Settings>
@@ -113,4 +119,52 @@
   </userSettings>
 
+  <system.serviceModel>
+    <bindings>
+      <netTcpBinding>
+        <binding name="NetBinding_IHiveService" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
+          maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security mode="TransportWithMessageCredential">
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </netTcpBinding>
+      <wsHttpBinding>
+        <binding name="WSHttpBinding_IHiveService" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    <services>
+      <service name="HeuristicLab.Clients.Hive.SlaveCore.SlaveCommunicationService">
+        <endpoint address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
+      </service>
+    </services>
+    <client>
+      <endpoint name="SlaveCommunicationServiceEndpoint" address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
+      <endpoint address="http://services.heuristiclab.com/Hive-3.3/HiveService.svc"
+        binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService"
+        contract="HeuristicLab.Clients.Hive.IHiveService" name="WSHttpBinding_IHiveService">
+        <identity>
+          <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ==" />
+        </identity>
+      </endpoint>
+      <endpoint address="net.tcp://services.heuristiclab.com/Hive-3.3/HiveService.svc"
+        binding="netTcpBinding" bindingConfiguration="NetBinding_IHiveService"
+        contract="HeuristicLab.Clients.Hive.IHiveService" name="NetBinding_IHiveService">
+        <identity>
+          <dns value="services.heuristiclab.com" />
+        </identity>
+      </endpoint>
+    </client>
+  </system.serviceModel>
+
   <runtime>
     <gcServer enabled="true"/>
Index: /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 15004)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 15005)
@@ -1,3 +1,3 @@
-<?xml version="1.0"?>
+<?xml version="1.0" encoding="utf-8"?>
 <configuration>
   <configSections>